private void Print_Click(object sender, RoutedEventArgs e)
{
	OrgChart.ScaleToFit();
	DeactivateControls();

	// prompt for a location to save it
	if (!bw.IsBusy && this.saveDialog.ShowDialog() == true)
	{
		// Determine optimal size for chart   
		width = (int)OrgChart.ActualWidth;
		height = (int)OrgChart.ActualHeight;
		zoomLevel = OrgChart.ZoomLevel;

		// Limit maximum image size to 8 000 pixels with
		int printWidth = Convert.ToInt32(width / zoomLevel);
		int printHeight = Convert.ToInt32(height / zoomLevel);
		if (printWidth > 6000)
		{
			printWidth = 6000;
			double ratio = width / Convert.ToDouble(height);
			printHeight = Convert.ToInt32(printWidth / ratio);
			zoomLevel = Convert.ToDouble(width) / printWidth;
		}

		WriteableBitmap wb = new WriteableBitmap(printWidth, printHeight);
		ScaleTransform scaleT = new ScaleTransform();
		scaleT.ScaleX = 1 / zoomLevel;
		scaleT.ScaleY = 1 / zoomLevel;
		wb.Render(OrgChart, scaleT);

		wb.Invalidate();

		// save bitmap to file
		using (Stream stream = this.saveDialog.OpenFile())
		{
			// encode the stream
			JPGUtil.EncodeJpg(wb, stream);
		}
	}

	ActivateControls();
}